/* This file is part of nanolisp, a very small Lisp system.

Copyright (C) 2007  Luca Saiu

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <stdbool.h>
#include <assert.h>
#include "nanolisp.h"
#include "interpreter.h"
#include "printer.h"

nanolisp_sexpression_t empty_list;

jmp_buf nanolisp_where_to_jump_in_case_of_error;

void nanolisp_repl(void){
  if(setjmp(nanolisp_where_to_jump_in_case_of_error) == 0){
    printf("=======================\n");
    printf("Welcome to nanolisp 0.1\n");
    printf("=======================\n\n");
    printf("nanolisp  Copyright (C) 2007  Luca Saiu\n");
    printf("This program comes with ABSOLUTELY NO WARRANTY; for details type\n");
    printf("(no-warranty)\n");
    printf("This is free software, and you are welcome to redistribute it\n");
    printf("under certain conditions; for detils type (license)\n");
    printf("\n");
    printf("An s-expression to be evaluated must be written *on a single line*\n");
    printf("in interactive mode.\n\n");
  } // if
  while(true){
    printf("nanolisp> ");
    nanolisp_sexpression_t sexpression = nanolisp_read_from_terminal();
    nanolisp_print(nanolisp_eval(sexpression,
                                 nanolisp_make_empty_list()));
    printf("\n");
  } // while
  printf("\nGoodbye.\n");
}
